server/api/urls.py
# -*- coding: utf-8 -*-

from django.conf.urls import patterns, url

urlpatterns = patterns(
    'api.views',


    url(r'^transactions/$', 'transactions_list'),

    url(r'^transactions/(?P<reference>.*)/logs/$', 'transactions_show_logs'),
    url(r'^transactions/(?P<reference>.*)/$', 'transactions_show'),

)

server/app/urls.py
from django.conf.urls import patterns, include, url
from django.conf import settings

# Uncomment the next two lines to enable the admin:
# from django.contrib import admin
# admin.autodiscover()

urlpatterns = patterns(
    '',

    (r'^users/login$', 'tequila.login'),
    (r'^users/logout$', 'django.contrib.auth.views.logout', {'next_page': '/'}),

    url(r'', include('main.urls')),
    url(r'^api/', include('api.urls')),
    url(r'^users/', include('users.urls')),
    url(r'^export/', include('export.urls')),
    url(r'^configs/', include('configs.urls')),
    url(r'^paiements/', include('paiements.urls')),
    url(r'^comparator/', include('comparator.urls')),

    (r'^' + settings.MEDIA_URL[1:] + '(?P<path>.*)$', 'django.views.static.serve', {'document_root': settings.MEDIA_ROOT}),  # In prod, use apache !
    (r'^' + settings.STATIC_URL[1:] + '(?P<path>.*)$', 'django.views.static.serve', {'document_root': settings.STATIC_ROOT}),  # In prod, use apache !
)

server/configs/urls.py
# -*- coding: utf-8 -*-

from django.conf.urls import patterns, url

urlpatterns = patterns(
    'configs.views',

    url(r'^$', 'list'),
    url(r'^(?P<pk>[0-9]+)/show/$', 'show'),
    url(r'^(?P<pk>[0-9]+)/edit/$', 'edit'),
    url(r'^(?P<pk>[0-9]+)/logs/$', 'show_logs'),

    #url(r'^(?P<pk>[0-9]+)/delete/$', 'delete'),

    url(r'^(?P<pk>[0-9]+)/keys/(?P<key_type>(ipn|requests|api))/new/$', 'new_key'),

)

server/configs/models.py
from django.db import models
from django.contrib.auth.models import User
from django.utils.html import escape
from django.utils.translation import ugettext_lazy as _

import uuid
import datetime
import hashlib
import random


class Config(models.Model):
    """Represent a website configuration"""

    name = models.CharField(max_length=255)

    active = models.BooleanField(default=True)
    admin_enable = models.BooleanField(default=True)

    test_mode = models.BooleanField(default=True)

    url_ipn = models.URLField()
    url_back_ok = models.URLField()
    url_back_err = models.URLField()

    key_request = models.CharField(max_length=255)
    key_ipn = models.CharField(max_length=255)
    key_api = models.CharField(max_length=255)

    allowed_users = models.ManyToManyField(User, blank=True)

    group = models.CharField(max_length=255, help_text=_('To group configs in summary'), blank=True, null=True)

    def __unicode__(self):
        bonus = u''

        if self.test_mode:
            bonus += u'<i class="fa fa-flask"></i>'

        if not self.active or not self.admin_enable:
            bonus += u'<i class="glyphicon glyphicon-ban-circle"></i>'

        if bonus:
            bonus = u' (' + bonus + u')'

        return escape(self.name) + bonus

    def build_user_list(self):
        """Return a list of user in text format"""
        return u','.join([user.username for user in self.allowed_users.order_by('username')])

    def generate_diff(self, other):
        """Generate diff from this objet an another one (for logs)"""
        retour = u'\n\n'

        for (prop, prop_name) in (('name', 'Name'), ('active', 'Active'), ('admin_enable', 'Admin enable'), ('test_mode', 'Test mode'), ('url_ipn', 'URL Ipn'), ('url_back_ok', 'Return URL for success'), ('url_back_err', 'Return URL for error'), ('group', 'Group')):
            if not other.pk or getattr(self, prop) != getattr(other, prop):
                retour += unicode(prop_name) + u'=' + unicode(getattr(self, prop))

                if other.pk:
                    retour += _(u' (was ') + unicode(getattr(other, prop)) + u')'

                retour += u'\n'

        retour += _(u'User list: ') + self.build_user_list()
        return retour

    def is_user_allowed(self, user):
        """Return true is a user is allowed to display / edit the config"""

        if user.is_superuser:
            return True
        elif not self.pk:
            return user.is_staff  # Only staff can create configs
        else:
            return user in list(self.allowed_users.all())

    def gen_key(self):
        """Return a random key suitable for keys of the model"""

        h = hashlib.sha512()

        for i in range(2):
            h.update(str(random.SystemRandom().random()))
            h.update(str(uuid.uuid4()))
            h.update(str(datetime.datetime.now()))
            h.update(str(self.pk))
            h.update(self.name)

        return h.hexdigest()

    def gen_key_api(self):
        """Generate a new key for api"""
        self.key_api = self.gen_key()

    def gen_key_ipn(self):
        """Generate a new key for ipn"""
        self.key_ipn = self.gen_key()

    def gen_key_request(self):
        """Generate a new key for requests"""
        self.key_request = self.gen_key()

    def save(self, *args, **kwargs):
        """Overide the save request to check if all keys have been generated"""

        if not self.key_api:
            self.gen_key_api()

        if not self.key_ipn:
            self.gen_key_ipn()

        if not self.key_request:
            self.gen_key_request()

        super(Config, self).save(*args, **kwargs)


class ConfigLogs(models.Model):

    config = models.ForeignKey(Config)
    user = models.ForeignKey(User)
    when = models.DateTimeField(auto_now_add=True)
    text = models.TextField()

server/configs/forms.py
from django.forms import ModelForm

from configs.models import Config


class ConfigForm(ModelForm):
    class Meta:
        model = Config
        exclude = ('key_request', 'key_ipn', 'key_api')

    def __init__(self, user, *args, **kwargs):
        super(ConfigForm, self).__init__(*args, **kwargs)

        if not user.is_superuser:
            del self.fields['admin_enable']

        if kwargs['instance'].pk:
            del self.fields['test_mode']

server/configs/views.py
# -*- coding: utf-8 -*-

from django.shortcuts import get_object_or_404, render, redirect
from django.template import RequestContext
from django.core.context_processors import csrf
from django.views.decorators.csrf import csrf_exempt
from django.http import Http404, HttpResponse, HttpResponseForbidden, HttpResponseNotFound
from django.utils.encoding import smart_str
from django.conf import settings
from django.contrib.admin.views.decorators import staff_member_required
from django.contrib.auth.decorators import login_required, user_passes_test
from django.http import HttpResponseRedirect
from django.db import connections
from django.core.paginator import InvalidPage, EmptyPage, Paginator
from django.core.cache import cache
from django.core.urlresolvers import reverse
from django.contrib import messages
from django.utils.translation import ugettext_lazy as _

from configs.models import Config, ConfigLogs
from configs.forms import ConfigForm
from django.contrib.auth.models import User


@login_required
def list(request):
    """Show the list of configs"""

    if request.user.is_superuser:
        configs = Config.objects.order_by('name')
    else:
        configs = Config.objects.filter(allowed_users=request.user).order_by('name')

    return render(request, 'configs/configs/list.html', {'list': configs})


@login_required
def edit(request, pk):
    """Edit or create a config"""

    try:
        config = Config.objects.get(pk=pk)
        create = False
    except:
        config = Config()
        create = True

    if not config.is_user_allowed(request.user):
        raise Http404

    if request.method == 'POST':  # If the form has been submitted...
        form = ConfigForm(request.user, request.POST, instance=config)

        if form.is_valid():  # If the form is valid

            config = form.save(commit=False)

            if not create:
                ConfigLogs(config=config, user=request.user, text=_('Config has been updated: ') + config.generate_diff(Config.objects.get(pk=pk))).save()

            config.save()  # To use allowed_users

            config.allowed_users.clear()

            for u in request.POST.getlist('allowed_users', []):
                config.allowed_users.add(User.objects.get(pk=u))
            config.allowed_users.add(request.user)
            config.save()

            if create:
                ConfigLogs(config=config, user=request.user, text=_('Config has been created: ') + config.generate_diff(Config())).save()

            messages.success(request, _('The config has been saved.'))

            return redirect('configs.views.list')
    else:
        form = ConfigForm(request.user, instance=config)

    return render(request, 'configs/configs/edit.html', {'form': form})


# @login_required
# @user_passes_test(lambda u: u.is_superuser)
# def delete(request, pk):
#     """Delete a config"""

#     object = get_object_or_404(Config, pk=pk)

#     if not object.is_user_allowed(request.user):
#         raise Http404

#     object.delete()
#     messages.success(request, _('Config has been deleted.'))

#     return redirect('configs.views.list')


@login_required
def show(request, pk):
    """Show a config"""

    object = get_object_or_404(Config, pk=pk)

    if not object.is_user_allowed(request.user):
        raise Http404

    return render(request, 'configs/configs/show.html', {'object': object})


@login_required
def new_key(request, pk, key_type):
    config = get_object_or_404(Config, pk=pk)

    if not config.is_user_allowed(request.user):
        raise Http404

    if key_type == "requests":
        config.gen_key_request()
    elif key_type == "ipn":
        config.gen_key_ipn()
    elif key_type == "api":
        config.gen_key_api()
    config.save()

    log_message = _(u"A new {} key has been generated".format(key_type))
    ConfigLogs(config=config, user=request.user, text=log_message).save()

    messages.success(request, log_message)

    return redirect('configs.views.show', pk=pk)


@login_required
def show_logs(request, pk):
    """Display config's logs"""

    config = get_object_or_404(Config, pk=pk)

    if not config.is_user_allowed(request.user):
        raise Http404

    list = config.configlogs_set.order_by('-when')

    return render(request, 'configs/configs/logs.html', {'object': config, 'list': list})

server/configs/templates/configs/configs/edit.html
{% extends "base.html" %}
{% load i18n %}
{% load bootstrap3 %}

{% block title %}{{block.super}} :: {% trans "Config management" %} :: {% trans "Edition" %}{% endblock %}

{% block content %}

<script type="text/javascript">$('#nav-configs').addClass('active');</script>

<h2>{% trans "Config management" %}</h2>

<ol class="breadcrumb">
  <li><a href="{% url 'main.views.home' %}"><i class="fa fa-home"></i> {% trans "Home" %}</a></li>
  <li><a href="{% url 'configs.views.list' %}"><i class="fa fa-cogs"></i> {% trans "Configs" %}</a></li>
  {% if form.instance.pk %}
    <li><a href="{% url 'configs.views.show' form.instance.pk %}"><i class="fa fa-cog"></i> {{form.instance|safe}}</a></li>
  {% endif %}
  <li class="active"><i class="fa fa-pencil"></i> {% if form.instance.pk %}{% trans "Edition" %}{% else %}{% trans "New config" %}{% endif %}</li>

</ol>

<div class="row-fluid">
    <div class="panel panel-primary">
        <div class="panel-heading">
            <h3 class="panel-title">{% trans "Edition of a config" %}</h3>
        </div>
        <div class="panel-body">

            <form action="" method="POST">
                {% csrf_token %}

                {% bootstrap_form form %}

                <div class="row-fluid box-section" style="text-align: right;">
                    <a href="{% url 'configs.views.list' %}" class="btn btn-default"><i class="glyphicon glyphicon-list"></i> {% trans "Back to the list" %}</a>
                    <input type="submit" class="btn btn-primary" value="{% trans "Save" %}">
                </div>

            </form>
            

        </div>
    </div>

</div>

<script type="text/javascript">
  $('#id_allowed_users').select2();
</script>


{% endblock %}

server/configs/templates/configs/configs/list.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}{{block.super}} :: {% trans "Configs" %} :: {% trans "List" %}{% endblock %}

{% block content %}

<script type="text/javascript">$('#nav-configs').addClass('active');</script>

<h2>{% trans "Configs" %}</h2>

<ol class="breadcrumb">
  <li><a href="{% url 'main.views.home' %}"><i class="fa fa-home"></i> {% trans "Home" %}</a></li>
  <li class="active"><i class="fa fa-cogs"></i> {% trans "Configs" %}</li>
</ol>

<div class="row-fluid">
    <div class="panel panel-primary">
        <div class="panel-heading">
            <h3 class="panel-title">{% trans "List of configs" %}</h3>
        </div>
        <div class="panel-body">
            <table cellpadding="0" cellspacing="0" border="0" class="table table-striped table-bordered table-to-sort">
                <thead>
                    <tr>
                        <th>{% trans "Name" %}</th>
                        <th>{% trans "URL Ipn" %}</th>
                        <th>{% trans "Test mode ?" %}</th>
                        <th>{% trans "Active ?" %}</th>
                        <th>{% trans "Admin enabled ?" %}</th>
                        <th style="width: 150px;"></th>
                    </tr>
                </thead>
                <tbody>
                    {% for elem in list %}
                        <tr>
                            <td><a href="{% url 'configs.views.show' elem.pk %}">{{elem.name}}</a></td>
                            <td>{{elem.url_ipn}}</td>
                            <td><span class="label label-{{elem.test_mode|yesno:"success,danger"}}">{{elem.test_mode|yesno}}</span></td>
                            <td><span class="label label-{{elem.active|yesno:"success,danger"}}">{{elem.active|yesno}}</span></td>
                            <td><span class="label label-{{elem.admin_enable|yesno:"success,danger"}}">{{elem.admin_enable|yesno}}</span></td>
                            <td>
                                <a href="{% url 'configs.views.show_logs' elem.pk %}" class="btn btn-xs btn-default"><i class="glyphicon glyphicon-list-alt"></i> {% trans "Logs" %}</a>
                                <a href="{% url 'configs.views.edit' elem.pk %}" class="btn btn-xs btn-primary"><i class="glyphicon glyphicon-pencil"></i> {% trans "Edit" %}</a>
                            </td>
                        </tr>
                    {% endfor %}
                    
                </tbody>
            </table>

            {% if user.is_superuser or user.is_staff %}
                <div class="row-fluid box-section" style="text-align: right;">
                    <a href="{% url 'configs.views.edit' '0' %}" class="btn btn-success"><i class="glyphicon glyphicon-plus"></i> {% trans "Add" %}</a>
                </div>
            {% endif %}

        </div>
    </div>

    

</div>

{% endblock %}

server/configs/templates/configs/configs/logs.html
{% extends "base.html" %}
{% load i18n %}
{% load bootstrap3 %}

{% block title %}{{block.super}} :: {% trans "Config management" %} :: {% trans "Logs" %}{% endblock %}

{% block content %}

<script type="text/javascript">$('#nav-configs').addClass('active');</script>

<h2>{% trans "Config management" %}</h2>

<ol class="breadcrumb">
  <li><a href="{% url 'main.views.home' %}"><i class="fa fa-home"></i> {% trans "Home" %}</a></li>
  <li><a href="{% url 'configs.views.list' %}"><i class="fa fa-cogs"></i> {% trans "Configs" %}</a></li>
  <li><a href="{% url 'configs.views.show' object.pk %}"><i class="fa fa-cog"></i> {{object|safe}}</a></li>
  <li class="active"><i class="glyphicon glyphicon-list-alt"></i> {% trans "Logs" %}</li>

</ol>

<div class="row-fluid">
    <div class="panel panel-primary">
        <div class="panel-heading">
            <h3 class="panel-title">{% trans "Logs for" %} {{object|safe}}</h3>
        </div>
        <div class="panel-body">

            <table cellpadding="0" cellspacing="0" border="0" class="table table-striped table-bordered table-to-sort-but-not-automaticaly">
                <thead>
                    <tr>
                        <th>{% trans "When" %}</th>
                        <th>{% trans "Who" %}</th>
                        <th>{% trans "What" %}</th>
                    </tr>
                </thead>
                <tbody>
                    {% for elem in list %}
                        <tr>
                            <td>{{elem.when|date}} {{elem.when|time}} ({{elem.when|timesince}} {% trans "ago" %})</td>
                            <td>{{elem.user.first_name}} {{elem.user.last_name}} ({{elem.user.username}})</td>
                            <td>{{elem.text|linebreaksbr}}</td>
                        </tr>
                    {% endfor %}
                    
                </tbody>
            </table>

            
                <div class="row-fluid box-section" style="text-align: right;">
                    <a href="{% url 'configs.views.list' %}" class="btn btn-default"><i class="glyphicon glyphicon-list"></i> {% trans "Back to the list" %}</a>
                    <a href="{% url 'configs.views.show' object.pk %}" class="btn btn-primary"> {% trans "Back to the config" %}</a>
                </div>

            

        </div>
    </div>

</div>


{% endblock %}

server/configs/templates/configs/configs/show.html
{% extends "base.html" %}
{% load i18n %}
{% load bootstrap3 %}

{% block title %}{{block.super}} :: {% trans "Configs management" %} :: {% trans "Details" %}{% endblock %}

{% block content %}

<script type="text/javascript">$('#nav-configs').addClass('active');</script>

<h2>{% trans "Configs management" %}</h2>

<ol class="breadcrumb">
  <li><a href="{% url 'main.views.home' %}"><i class="fa fa-home"></i> {% trans "Home" %}</a></li>
  <li><a href="{% url 'configs.views.list' %}"><i class="fa fa-cogs"></i> {% trans "Configs" %}</a></li>
  <li class="active"><i class="fa fa-cog"></i> {{object|safe}}</li>

</ol>

<div class="row-fluid">

    {% if not object.active or not object.admin_enable %}
      <p class="alert alert-danger well-sm">
        <i class="glyphicon glyphicon-ban-circle"></i> {% trans "This configuration is disabled !" %}
      </p>
    {% endif %}

    {% if object.test_mode %}
      <p class="alert alert-info well-sm">
        <i class="fa fa-flask"></i> {% trans "This configuration is in test mode !" %}
      </p>
    {% endif %}



    <div class="panel panel-primary">
        <div class="panel-heading">
            <h3 class="panel-title">{% trans "Details of a config" %}</h3>
        </div>
        <div class="panel-body">

          <form>
              
              <div class="form-group">
                <label>{% trans "Name" %}</label>
                <p class="form-control-static">{{object.name}}</p>
              </div>

              {% if object.group %}
                <div class="form-group">
                  <label>{% trans "Group" %}</label>
                  <p class="form-control-static">{{object.group}}</p>
                </div>
              {% endif %}

              <div class="form-group">
                <label>{% trans "URL Ipn" %}</label>
                <p class="form-control-static">{{object.url_ipn}}</p>
              </div>

              <div class="form-group">
                <label>{% trans "Return URL, if success" %}</label>
                <p class="form-control-static">{{object.url_back_ok}}</p>
              </div>

              <div class="form-group">
                <label>{% trans "Return URL, if error" %}</label>
                <p class="form-control-static">{{object.url_back_err}}</p>
              </div>

              <div class="form-group">
                <label>{% trans "Test mode ?" %}</label>
                <p class="form-control-static"><span class="label label-{{object.test_mode|yesno:"success,danger"}}">{{object.test_mode|yesno}}</span></p>
              </div>

              <div class="form-group">
                <label>{% trans "Is active ?" %}</label>
                <p class="form-control-static"><span class="label label-{{object.active|yesno:"success,danger"}}">{{object.active|yesno}}</span></p>
              </div>

              <div class="form-group">
                <label>{% trans "Is admin enabled ?" %}</label>
                <p class="form-control-static"><span class="label label-{{object.admin_enable|yesno:"success,danger"}}">{{object.admin_enable|yesno}}</span></p>
              </div>

              <div class="form-group">
                <label>{% trans "Config ID" %}</label>
                <p class="form-control-static">{{object.pk}}</p>
              </div>

              <div class="form-group">
                <label>{% trans "Key for requests" %}</label>
                <p class="form-control-static">
                  <span class="btn btn-xs btn-default btn-key" x-key="{{object.key_request}}">{% trans "Copy" %}</span> {{object.key_request|truncatechars:9}}
                  <a class="btn btn-xs btn-danger" onclick="return confirm('{% trans "Are you sure ?" %}');" href="{% url 'configs.views.new_key' object.pk 'requests' %}">{% trans "Generate a new one" %}</a>
                </p>
              </div>

              <div class="form-group">
                <label>{% trans "Key for IPN" %}</label>
                <p class="form-control-static">
                  <span class="btn btn-xs btn-default btn-key" x-key="{{object.key_ipn}}">{% trans "Copy" %}</span> {{object.key_ipn|truncatechars:9}}
                  <a class="btn btn-xs btn-danger" onclick="return confirm('{% trans "Are you sure ?" %}');" href="{% url 'configs.views.new_key' object.pk 'ipn' %}">{% trans "Generate a new one" %}</a>
                </p>
              </div>

              <div class="form-group">
                <label>{% trans "Key for API" %}</label>
                <p class="form-control-static">
                  <span class="btn btn-xs btn-default btn-key" x-key="{{object.key_api}}">{% trans "Copy" %}</span> {{object.key_api|truncatechars:9}}
                  <a class="btn btn-xs btn-danger" onclick="return confirm('{% trans "Are you sure ?" %}');" href="{% url 'configs.views.new_key' object.pk 'api' %}">{% trans "Generate a new one" %}</a>
                </p>
              </div>

              <div class="form-group">
                <label>{% trans "Users allowed" %}</label>
                <p class="form-control-static">
                    {% if object.allowed_users.all %}
                      <ul>
                        {% for u in object.allowed_users.all %}
                          <li>{{u.first_name}} {{u.last_name}} ({{u}})</li>
                        {% endfor %}
                      </ul>
                    {% else %}

                      <p class="alert alert-warning well-sm" style="display: inline-block;">
                        {% trans "Only admins can use this config" %}
                      </p>

                    {% endif %}

                </p>
              </div>

          </form>

          <div class="row-fluid box-section" style="text-align: right;">
              <a href="{% url 'configs.views.list' %}" class="btn btn-default"><i class="glyphicon glyphicon-list"></i> {% trans "Back to the list" %}</a>
              <a href="{% url 'configs.views.show_logs' object.pk %}" class="btn btn-default"><i class="glyphicon glyphicon-list-alt"></i> {% trans "Logs" %}</a>
              <a href="{% url 'configs.views.edit' object.pk %}" class="btn btn-primary"><i class="glyphicon glyphicon-pencil"></i> {% trans "Edit" %}</a>
          </div>            

        </div>
    </div>

</div>

<script type="text/javascript" src="{{MEDIA_URL}}ZeroClipboard.js"></script>

  <script type="text/javascript">

    $(document).ready(function(){

       $(".btn-key").zclip({
          path: "{{MEDIA_URL}}ZeroClipboard.swf",
          copy: function(){
              return $(this).attr('x-key');
              },
          afterCopy: function() {
            $('.btn-key').removeClass('btn-success');
            $('.btn-key').html('{% trans "Copy" %}');
            $(this).addClass('btn-success');

            $(this).html('{% trans "Copied !" %}');
          }
          });
      });
  </script>

{% endblock %}